<?php

# for Old Version of PluginArchitecture
function plugin_init_haruca() {
}

function plugin_haruca_install() {

   api_plugin_register_hook('haruca', 'config_arrays',         'haruca_config_arrays',        "setup.php");
   api_plugin_register_hook('haruca', 'draw_navigation_text',  'haruca_draw_navigation_text', "setup.php");
   api_plugin_register_hook('haruca', 'config_settings',       'haruca_config_settings',      "setup.php");
   api_plugin_register_hook('haruca', 'top_header_tabs',       'haruca_show_tab',             "setup.php");
   api_plugin_register_hook('haruca', 'top_graph_header_tabs', 'haruca_show_tab',             "setup.php");

   api_plugin_register_realm('haruca', 'haruca.php', 'Plugin -> haruca view', 1);
   api_plugin_register_realm('haruca', 'haruca_config', 'Plugin -> haruca configure', 1);

   api_plugin_register_hook('haruca', 'config_form',           'haruca_config_form',          "setup.php");
   api_plugin_register_hook('haruca', 'api_graph_save',        'haruca_api_graph_save',       "setup.php");
   api_plugin_register_hook('haruca', 'body_style', 'haruca_api_plugin_hook_function_body_style', "setup.php");
   api_plugin_register_hook('haruca', 'top_graph_refresh',     'haruca_top_graph_refresh',    "setup.php");

   haruca_setup_table_new ();

}


function haruca_api_graph_save ($save) {
  /* what happend after a click on the save button */
}

function haruca_api_plugin_hook_function_body_style () {
}

/* plugin uninstall - a generic uninstall routine.  Right now it will do nothing as I
   If you don't want the tables removed from the system except let it empty. */
function plugin_haruca_uninstall () {
	/* Do any extra Uninstall stuff here */

  $sql = array();
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_host`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_office`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_category`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_logtype`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_cat_get_log`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_log`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_logold`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_rtt`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_traplog`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_traptype`;";
  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_settings`;";

  for($a = 0; $a < count($sql); $a++) {
    mysql_query($sql[$a]) or die (mysql_error());
  }

}

function plugin_haruca_check_config () {
	/* Here we will check to ensure everything is configured */
	return true;
}

function plugin_haruca_upgrade () {
	/* Here we will upgrade to the newest version */
	haruca_check_upgrade();
	return false;
}

function plugin_haruca_version () {
	return haruca_version();
}

function haruca_check_upgrade () {
	global $config;

	$files = array('index.php', 'plugins.php', 'haruca.php');
	if (isset($_SERVER['PHP_SELF']) && !in_array(basename($_SERVER['PHP_SELF']), $files)) {
		return;
	}

	$current = plugin_haruca_version();
	$current = $current['version'];
	$old     = db_fetch_row("SELECT * FROM plugin_config WHERE directory='haruca'");
	if (sizeof($old) && $current != $old["version"]) {
		/* if the plugin is installed and/or active */
		if ($old["status"] == 1 || $old["status"] == 4) {
			/* re-register the hooks */
			plugin_haruca_install();

			/* perform a database upgrade */
			haruca_database_upgrade();
		}

		/* update the plugin information */
		$info = plugin_haruca_version();
		$id   = db_fetch_cell("SELECT id FROM plugin_config WHERE directory='haruca'");
		db_execute("UPDATE plugin_config
			SET name='" . $info["longname"] . "',
			author='"   . $info["author"]   . "',
			webpage='"  . $info["homepage"] . "',
			version='"  . $info["version"]  . "'
			WHERE id='$id'");
	}
}

function haruca_check_dependencies() {
	global $plugins, $config;
	return true;
}

function haruca_database_upgrade () {
}

function haruca_setup_table_new () {
  # create table if not exists ....
  mysql_query("SET NAMES 'utf8'");

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_host`;";
  $sql[] = "CREATE TABLE `plugin_haruca_host` (
            `id`            mediumint(8) unsigned not null primary key ,
            `categorycode`  mediumint(8) unsigned  default NULL,
            `officecode`    mediumint(8) unsigned  default NULL,
            `model`         varchar(32)            default NULL,
            `version`       varchar(32)            default NULL,
            `serial`        varchar(32)            default NULL
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_office`;";
  $sql[] = "create table `plugin_haruca_office` (
            `officecode`      mediumint(8) unsigned not null primary key auto_increment,
            `officename`      varchar(32)           not null ,
            `officeaddress`   varchar(128)          not null
          ) ENGINE=MyISAM;";



  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_category`;";
  $sql[] = "create table plugin_haruca_category(
            `categorycode` mediumint(8) unsigned not null primary key auto_increment,
            `categoryname` varchar(32)     not null,
            `login_method` varchar(32)     default NULL,
            `prepare_cmd`  varchar(32)     default NULL,
            `enable_cmd`   varchar(32)     default NULL,
            `uid_prompt`   varchar(32)     default NULL,
            `pwd_prompt`   varchar(32)     default NULL,
            `en_prompt`    varchar(32)     default NULL,
            `username`     varchar(32)     default NULL,
            `vtypass`      varchar(32)     default NULL,
            `enable`       varchar(32)     default NULL
           ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_logtype`;";
  $sql[] = "create table plugin_haruca_logtype(
            `logtypecode` tinyint unsigned not null primary key auto_increment,
            `logname`     varchar(16)  not null,
            `loggetcmd`   varchar(256) not null,
            `ignore_str`  varchar(256) ,
            `diffcheck`       tinyint not null,
            `cycle`       tinyint not null
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_cat_get_log`;";
  $sql[] = "create table plugin_haruca_cat_get_log(
            `categorycode` mediumint(8) unsigned not null,
            `logtypecode`  tinyint unsigned not null,
            `available`  tinyint(1) unsigned not null default 1
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_log`;";
  $sql[] = "create table plugin_haruca_log(
            `hostcode`     smallint unsigned not null,
            `logtypecode`  tinyint  unsigned not null,
            `gettime`      timestamp  not null,
            `value`        mediumtext not null
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_logold`;";
  $sql[] = "create table plugin_haruca_logold(
            `hostcode`     smallint unsigned not null,
            `logtypecode`  tinyint  unsigned not null,
            `gettime`      timestamp  not null,
            `value`        mediumblob not null
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_rtt`;";
  $sql[] = "create table plugin_haruca_rtt(
            `hostcode`    smallint unsigned not null default 0,
            `gettime`     timestamp  not null default current_timestamp,
            `value`       smallint  not null default 0
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_traplog`;";
  $sql[] = "create table plugin_haruca_traplog(
            `hostcode`   smallint unsigned not null default 0,
            `oidstring`  varchar(50) not null,
            `gettime`    timestamp   not null,
            `target`       varchar(500) default NULL,
            `summary`      varchar(500) default NULL,
            `description`  varchar(50) default NULL,
            `address`      varchar(20) default NULL
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_traptype`;";
  $sql[] = "create table plugin_haruca_traptype(
            `oidstring`    varchar(50) not null,
            `trapname`     varchar(50) not null,
            `target`       varchar(100) default NULL,
            `summary`      varchar(100) default NULL,
            `available`    tinyint(1)  not null  default '1' ,
            `alertmail`    tinyint(1)  not null  default '0'
          ) ENGINE=MyISAM;";

  $sql[] = "DROP TABLE IF EXISTS `plugin_haruca_settings`;";
  $sql[] = "create table plugin_haruca_settings(
            `item`    varchar(100) not null,
            `value`   varchar(100) default null
          ) ENGINE=MyISAM;";
  
  $sql[] = "insert into plugin_haruca_logtype (logname,loggetcmd,ignore_str,diffcheck,cycle) values ('start', 'show start'     ,'Using..*out of..*bytes|^\\ *\\!',1,7);";
  $sql[] = "insert into plugin_haruca_logtype (logname,loggetcmd,ignore_str,diffcheck,cycle) values ('run',   'show run'       ,'Using..*out of..*bytes|^\\ *\\!|ntp clock-period|Current configuration',1,7);";
  $sql[] = "insert into plugin_haruca_logtype (logname,loggetcmd,diffcheck,cycle) values ('logging', 'show logging'     ,0,7);";
  $sql[] = "insert into plugin_haruca_logtype (logname,loggetcmd,diffcheck,cycle) values ('inter', 'show inter'     ,0,7);";
  $sql[] = "insert into plugin_haruca_logtype (logname,loggetcmd,diffcheck,cycle) values ('tech',  'show tech'      ,0,7);";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname) values ('pingfail',    'PingFail');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname) values ('pingsuccess', 'PingSuccess');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,summary) values ('.1.3.6.1.6.3.1.1.5.1', 'ColdStart', '.1.3.6.1.4.1.9.2.1.2');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,summary) values ('.1.3.6.1.6.3.1.1.5.2', 'WarmStart', '.1.3.6.1.4.1.9.2.1.2');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,target,summary) values ('.1.3.6.1.6.3.1.1.5.3', 'LinkDown',  '.1.3.6.1.2.1.2.2.1.2','.1.3.6.1.4.1.9.2.2.1.1.20');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,target,summary) values ('.1.3.6.1.6.3.1.1.5.4', 'LinkUp',    '.1.3.6.1.2.1.2.2.1.2','.1.3.6.1.4.1.9.2.2.1.1.20');";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,summary,available) values ('.1.3.6.1.4.1.9.0.1', 'TelnetLogin', '.1.3.6.1.4.1.9.2.6.1.1.1.\$IP.\$NUM.',0);";
  $sql[] = "insert into plugin_haruca_traptype (oidstring,trapname,available) values ('.1.3.6.1.4.1.9.9.43.2.0.1', 'ConfigChange', 0);";
  $sql[] = "insert into plugin_haruca_category (categoryname) values ('SNMPONLY');";
  $sql[] = "insert into plugin_haruca_category (categoryname,login_method,prepare_cmd,enable_cmd,pwd_prompt,en_prompt,vtypass,enable) values ('cisco','telnet','term len 0','enable','Password:','Password:','password','enable');";
  $sql[] = "insert into plugin_haruca_category (categoryname,login_method,prepare_cmd,uid_prompt,username,enable_cmd,pwd_prompt,en_prompt,vtypass,enable) values ('cisco_user','telnet','term len 0','Username:','user','enable','Password:','Password:','password','enable');";

  $sql[] = "insert into plugin_haruca_office (officename,officeaddress) values ('NODATA','NODATA');";

  $sql[] = "insert into plugin_haruca_settings (item,value) values ('lastupdate_period','7');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('proc_per_thread','10');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_smtp_server','127.0.0.1');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_email_to_address','example@example.com');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_email_from_name','haruca alert');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_email_from_address','example@example.com');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_ipmsg_address','');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('alert_ipmsg_port','2425');";
  $sql[] = "insert into plugin_haruca_settings (item,value) values ('reload_period','30');";


  $sql_select  = "select id from host";
  $result = mysql_query($sql_select) or die (mysql_error());
  while($row = mysql_fetch_assoc($result)){
    $sql[]  = "insert into plugin_haruca_host set id = ".$row['id']." , categorycode = 1 ,  officecode = 1";
  }

  for($a = 0; $a < count($sql); $a++) {
    mysql_query($sql[$a]) or die (mysql_error());
  }

}

function haruca_version () {
    return array( 'name'     => 'haruca',
            'version'        => '0.1.7',
            'longname'       => 'Cisco router utility',
            'author'         => 'bashaway',
            'homepage'       => 'http://www.prosper2.org/devwiki/index.php?haruca',
            'email'          => 'haruca.tech@gmail.com',
            'url'            => 'https://www.prosper2.org/devwiki/index.php?haruca'
            );
}


function haruca_device_action_execute ($action) {
        global $config;

        if ($action != 'haruca_your_action')
                return;
        /* Look at monitor as example */
        return;
}

function haruca_device_action_prepare($save) {
        global $colors, $host_list;
        /* Look at monitor as example */
}

function haruca_device_action_array($device_action_array) {
        /* here you can add actions in the devices view */
        /* Look at monitor as example */
#        $device_action_array['haruca_your_action'] = 'haruca action';
        return $device_action_array;
}

function haruca_top_graph_refresh ($refresh) {
        /* change the refresh time of your view. Here as example haruca.php */
        /* haruca_refresh is supposed to be one parameter of the setting */
        if (basename($_SERVER['PHP_SELF']) != 'haruca.php')
                return $refresh;
        $r = read_config_option('haruca_refresh');
        if ($r == '' or $r < 1)
                return $refresh;
        return $r;
}

function haruca_config_settings(){
}


function haruca_show_tab () {

  global $config, $haruca_tab;
  include_once($config["library_path"] . "/database.php");
  include_once($config["base_path"] . "/plugins/haruca/config.php");
  if (api_user_realm_auth('haruca.php')) {
    if (!substr_count($_SERVER["REQUEST_URI"], "haruca.php")) {
      print '<a href="' . $config['url_path'] . 'plugins/haruca/haruca.php"><img src="' .
                $config['url_path'] . 'plugins/haruca/images/tab_haruca.png" alt="haruca" align="absmiddle" border="0"></a>';
    }else{
      print '<a href="' . $config['url_path'] . 'plugins/haruca/haruca.php"><img src="' .
                $config['url_path'] . 'plugins/haruca/images/tab_haruca_down.png" alt="haruca" align="absmiddle" border="0"></a>';
    }
  }


}

function haruca_config_arrays () {
  global $menu, $config, $haruca_tab;
  include_once($config["base_path"] . "/plugins/haruca/config.php");


  if(!$haruca_tab){
    $temp = $menu["Utilities"]['logout.php'];
    unset($menu["Utilities"]['logout.php']);
    $menu["Utilities"]['plugins/haruca/haruca.php'] = "haruca";
    $menu["Utilities"]['logout.php'] = $temp;
  }

}

function haruca_draw_navigation_text ($nav) {
   /* insert all your PHP functions that are accessible */
   $nav['haruca.php:'] = array('title' => 'haruca', 'mapping' => '', 'url' => 'haruca.php', 'level' => '0');

   $nav['haruca.php:show_statuscheck']           = array('title' => 'ShowStatusCheck', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:show_statuscheckold']        = array('title' => 'ShowStatusCheckOld', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:show_traps']                 = array('title' => 'ShowTraps', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:show_logs_execute']          = array('title' => 'ShowLogsExecute', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:show_logs']                  = array('title' => 'ShowLogs', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:show_hosts']                 = array('title' => 'ShowHosts', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');

   $nav['haruca.php:manage_config']              = array('title' => 'ManageConfig', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_export']              = array('title' => 'ManageExport', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_host']                = array('title' => 'ManageHost', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_category']            = array('title' => 'ManageCategory', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_office']              = array('title' => 'ManageOffice', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_logtype']             = array('title' => 'ManageLogType', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manage_traptype']            = array('title' => 'ManageTrapType', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');

   $nav['haruca.php:reset_config']               = array('title' => 'ResetConfig', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');

   $nav['haruca.php:tool_configchanger']         = array('title' => 'ConfigChanger', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:tool_bwcalc']                = array('title' => 'BandWidthCalculate', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:tool_configchanger_execute'] = array('title' => 'ConfigChangerExecute', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:tool_shell']                 = array('title' => 'EasyShell', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:tool_wcmcalc']               = array('title' => 'WildCardMaskCalculate', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');

   $nav['haruca.php:manual_setup']               = array('title' => 'Setup', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   $nav['haruca.php:manual_command']             = array('title' => 'CLI command', 'mapping' => 'haruca.php:', 'url' => 'haruca.php', 'level' => '1');
   return $nav;

}



?>
